"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HasExtension = void 0;
const class_validator_1 = require("class-validator");
const parse_array_util_1 = require("../../utils/parse-array.util");
const HasExtension = (extensions, validationOptions) => {
    return (0, class_validator_1.ValidateBy)({
        name: "hasExtension",
        constraints: [extensions, validationOptions],
        validator: {
            validate(value, args) {
                const [extensions] = args.constraints;
                if (value) {
                    const files = (0, parse_array_util_1.parseArray)(value);
                    return files.every(file => extensions.includes(file.extension));
                }
                return true;
            },
            defaultMessage: (validationArguments) => {
                const allowedExtensions = (0, parse_array_util_1.parseArray)(validationArguments?.constraints[0]);
                return `Allowed extensions are: ${allowedExtensions.join(", ")}`;
            },
        },
    });
};
exports.HasExtension = HasExtension;
