"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HasMimeFile = void 0;
const class_validator_1 = require("class-validator");
const parse_array_util_1 = require("../../utils/parse-array.util");
const HasMimeFile = (mimes, options) => {
    return (0, class_validator_1.ValidateBy)({
        name: "HasMime",
        constraints: [mimes],
        validator: {
            validate(value, args) {
                const [mimes] = args.constraints;
                return value && (0, parse_array_util_1.parseArray)(value).every(file => mimes.includes(file.mimeType));
            },
            defaultMessage(args) {
                const [mimes] = args.constraints;
                const mimesAllowed = mimes.join(",");
                return `Field "${args.property}" does not contain file with allowed mime type. Allowed mime types: ${mimesAllowed}`;
            },
        },
    }, options);
};
exports.HasMimeFile = HasMimeFile;
