"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsFile = void 0;
const class_validator_1 = require("class-validator");
const file_processor_1 = require("../../processors/file-processor");
const IsFile = (options) => {
    return (0, class_validator_1.ValidateBy)({
        name: "IsFile",
        constraints: [],
        validator: {
            validate(value) {
                if (options && options.each) {
                    if (!Array.isArray(value)) {
                        return [value].every(item => file_processor_1.FileProcessor.isFile(item));
                    }
                    return Array.isArray(value) && value.every(item => file_processor_1.FileProcessor.isFile(item));
                }
                return !Array.isArray(value) && file_processor_1.FileProcessor.isFile(value);
            },
            defaultMessage(args) {
                return options && options.each
                    ? `${args.property} Each value must be a file`
                    : `${args.property} Value must be a file`;
            },
        },
    }, options);
};
exports.IsFile = IsFile;
