"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MaxFileSize = void 0;
const class_validator_1 = require("class-validator");
const parse_array_util_1 = require("../../utils/parse-array.util");
const MaxFileSize = (maxSize, options) => {
    return (0, class_validator_1.ValidateBy)({
        name: "MaxFileSize",
        constraints: [maxSize],
        validator: {
            validate(value, args) {
                const [maxSize] = args.constraints;
                return value && (0, parse_array_util_1.parseArray)(value).every(file => file.buffer.length <= maxSize);
            },
            defaultMessage(args) {
                const [maxSize] = args.constraints;
                return `Field "${args.property}" does not contain file with size less than ${maxSize} bytes`;
            },
        },
    }, options);
};
exports.MaxFileSize = MaxFileSize;
