"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MinFileSize = void 0;
const class_validator_1 = require("class-validator");
const parse_array_util_1 = require("../../utils/parse-array.util");
const MinFileSize = (minSize, options) => {
    return (0, class_validator_1.ValidateBy)({
        name: "MinFileSize",
        constraints: [minSize],
        validator: {
            validate(value, args) {
                const [minSize] = args.constraints;
                return value && (0, parse_array_util_1.parseArray)(value).every(file => file.buffer.length >= minSize);
            },
            defaultMessage(args) {
                const [minSize] = args.constraints;
                return `Field "${args.property}" does not contain file with size greater than ${minSize} bytes`;
            },
        },
    }, options);
};
exports.MinFileSize = MinFileSize;
