"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormDataInterceptor = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const rxjs_1 = require("rxjs");
const inject_config_constant_1 = require("../constants/inject-config.constant");
const file_upload_decorator_1 = require("../decorators/file-upload.decorator");
const form_processor_1 = require("../utils/form-processor");
const parse_config_util_1 = require("../utils/parse-config.util");
let FormDataInterceptor = class FormDataInterceptor {
    globalConfig;
    reflect = new core_1.Reflector();
    constructor(globalConfig) {
        this.globalConfig = globalConfig;
    }
    async intercept(context, next) {
        const request = context.switchToHttp().getRequest();
        if (!this.isFormData(request.headers)) {
            const message = "Sorry, only multipart/form-data is supported";
            throw new common_1.BadRequestException(message);
        }
        const config = (0, parse_config_util_1.parseConfig)(this.globalConfig ?? {}, this.reflect.get(file_upload_decorator_1.FILE_UPLOAD_OPTIONS, context.getHandler()) ?? {});
        const formProcessor = new form_processor_1.FormProcessor(request, config);
        return (0, rxjs_1.from)(formProcessor.handle()).pipe((0, rxjs_1.mergeMap)(result => {
            request.body = result;
            return next.handle();
        }), (0, rxjs_1.catchError)(error => {
            throw error;
        }));
    }
    isFormData(headers) {
        const contentType = headers["content-type"] || "";
        return contentType.includes("multipart/form-data");
    }
};
FormDataInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(inject_config_constant_1.InjectConfig)),
    __metadata("design:paramtypes", [Object])
], FormDataInterceptor);
exports.FormDataInterceptor = FormDataInterceptor;
