/// <reference types="node" />
import { FileProcessorMetadata, FileProcessorOptions } from "../interfaces/file-processor.interface";
import { FileUploadOptionsBase } from "../interfaces/file-upload-options.interface";
export declare abstract class FileProcessor<T> {
    private options;
    constructor(options: FileProcessorOptions);
    abstract process(): Promise<T>;
    static isFile(file: any): boolean;
    protected getBuffer(): Buffer;
    protected getSize(): number;
    protected getResized(): Promise<Buffer | null>;
    protected getMetadata(): FileProcessorMetadata;
    protected getExtension(): string;
    getConfig<T extends FileUploadOptionsBase>(): T["options"] & {
        folder?: string;
    };
}
