"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileProcessorFactory = void 0;
const file_upload_provider_enum_1 = require("../enums/file-upload-provider.enum");
const memory_disk_processor_1 = require("./implementations/memory/memory-disk-processor");
class FileProcessorFactory {
    static create(options, config) {
        const { provider } = config;
        switch (provider) {
            case file_upload_provider_enum_1.FileUploadProvider.MEMORY:
                return new memory_disk_processor_1.MemoryDiskProcessor(options);
            default:
                throw new Error("Sorry, we don't support this driver yet.");
        }
    }
}
exports.FileProcessorFactory = FileProcessorFactory;
